#!/bin/bash

passes=0
fails=0
skips=0

echo "Test run starting at" `date`

while [ $# -ge 1 ] ; do
	this_test=$1
	shift
	echo "Starting $this_test"
	$this_test 2>&1
	res=$?
	if [ $res -eq 0 ]; then
		str="";
		passes=$((passes + 1));
	elif [ $res -eq 3 ]; then
		str=" -- SKIPPED";
		skips=$((skips + 1));
	else
		str=" -- FAILED"
		fails=$((fails + 1));
	fi
	echo "Completed $this_test with $res$str".
done

echo "Pass: $passes  Fail: $fails  Skip: $skips"
echo "Test run complete at" `date`

exit $fails
